## ros-indigo-humanoid-localization 0.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(humanoid_localization)

find_package(catkin REQUIRED COMPONENTS roscpp pcl_conversions pcl_ros message_filters sensor_msgs cmake_modules)
find_package(OpenMP)
find_package(Boost REQUIRED COMPONENTS random)
find_package(Eigen REQUIRED)
find_package(octomap REQUIRED)
include_directories(${OCTOMAP_INCLUDE_DIRS})
link_libraries(${OCTOMAP_LIBRARIES})

# required for OpenMP
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")

SET(LIBRARIES mapmodel motionmodel observationmodel raycastingmodel)

find_package(dynamicEDT3D)
if (${dynamicEDT3D_FOUND})                                                                       
  include_directories(${DYNAMICEDT3D_INCLUDE_DIRS})                                                          
  link_directories(${DYNAMICEDT3D_LIBRARY_DIRS})
  LINK_LIBRARIES(${OCTOMAP_LIBRARIES} ${DYNAMICEDT3D_LIBRARIES})
  list(APPEND LIBRARIES endpointmodel)
else (${dynamicEDT3D_FOUND})
  MESSAGE(WARNING "dynamicEDT3D library (part of OctoMap >1.5) not found, skipping endpoint model")
  add_definitions(-DSKIP_ENDPOINT_MODEL)
endif (${dynamicEDT3D_FOUND})

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${LIBRARIES} humanoidlocalization
  CATKIN_DEPENDS tf
  DEPENDS octomap OpenMP
)

include_directories(include
  ${catkin_INCLUDE_DIRS}
)

if (${dynamicEDT3D_FOUND})
  add_library(endpointmodel src/EndpointModel.cpp)
endif (${dynamicEDT3D_FOUND})

add_library(mapmodel src/MapModel.cpp)
add_library(motionmodel src/MotionModel.cpp)
add_library(observationmodel src/ObservationModel.cpp)

add_library(raycastingmodel src/RaycastingModel.cpp)
target_link_libraries(raycastingmodel observationmodel)

add_library(humanoidlocalization src/HumanoidLocalization.cpp)
target_link_libraries(humanoidlocalization ${LIBRARIES} ${catkin_LIBRARIES})

add_executable(localization_node src/localization_node.cpp)
target_link_libraries(localization_node humanoidlocalization ${catkin_LIBRARIES})

# install
install(TARGETS ${LIBRARIES} humanoidlocalization
        DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
) 
install(TARGETS localization_node
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

=== debian/changelog ===
ros-indigo-humanoid-localization (0.4.1-2trusty) trusty; urgency=high

  * catkinize the stack
  * get code to compile under Hydro
  * removes some trailing blanks and semicolon
  * added localization Service to HumanoidLocalization (untested)
  * Localization updates are now done based on the distance to the last localized pose (not summed distance)
  * Homogeneous subsampling of laser points (PCL voxel grid) instead of angular
  * Uniform sampling for depth camera data
  * Motion model and noise can now be calibrated with a variance matrix. Some parameters are no longer used, please adjust accordingly:
    motion_noise/x, motion_noise/y, motion_noise/yaw, num_sensor_beams
  * Preventing TF_OLD_DATA Warning when init from RVIZ
  * refactoring/cleanup
  * Added Timer to Localization and timerCallback now republishes latest tf transform
  * added parameterization for odometry calibration in MotionModel
  * Proper floor offset if z is constrained to supporting surface by kinematics / odometry
  * More loops parallelized (motion model)
  * fixes:
    
      * Fixed invalid conversion from 'octomap::AbstractOcTree*' to 'octomap::OcTree*'
      * Add dependency to cmake_modules for FindEigen.cmake
      * Fixed duplicate library export
      * Fixed linking endpointmodel to humanoidlocalization in case dynamicEDT3D is available
      * Fix missing OpenMP compilation flags (from catkinization)
      * Fixing error with constrainMotion flags and optimized-away assertion
      * Fixed point cloud callback crashing when ground filtering and no ground visible
      * Bugfix for OctoMap in Groovy
      * Height lookup for endpoint model fixed
      * Fixed raycasting height integration on non-zero ground and raycast max_range
      * bug fix: removed (unnecessary) feature in HumanoidLocalization
      * Fixed compilation with ROS groovy (tf types)
      * fixed localization for point clouds
    
  * Contributors: Armin Hornung, Daniel Maier, Pramuditha Aravinda, Stefan Osswald, Vincent Rabaud, enriquefernandez

 -- Armin Hornung <HornungA@informatik.uni-freiburg.de>  Sun, 04 Sep 2016 18:30:00 -0000

ros-indigo-humanoid-localization (0.4.0-2trusty) trusty; urgency=high

  * indentation / code style
  * added point cloud support (with ground filter) to humanoid_localization
  * Added option to constrain motion according to odometry (don't estimate z / RP)
  * cleanup, init localization from ground truth via tf lookup
  * Fixed odometry lookup error (wrong frame) and missing odom data
  * restructuring of humanoid_localization started
  * Parameter cleanup / renaming
  * Better height measurement in raycasting model
  * humanoid_localization now uses sensor_msgs::Imu instead of nao_msgs
  * EndpointModel is now optional, depends on dynamicEDT3D
  * humanoid_localization added to humanoid_navigation, currently supports 6D localization from laser, odometry and IMU
  * Contributors: Armin Hornung, Daniel Maier

 -- Armin Hornung <HornungA@informatik.uni-freiburg.de>  Wed, 09 Jan 2013 18:30:00 -0000

=== debian/control ===
Source: ros-indigo-humanoid-localization
Section: misc
Priority: extra
Maintainer: Armin Hornung <HornungA@informatik.uni-freiburg.de>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-cmake-modules, ros-indigo-geometry-msgs, ros-indigo-message-filters, ros-indigo-nav-msgs, ros-indigo-octomap, ros-indigo-octomap-msgs, ros-indigo-octomap-ros, ros-indigo-pcl-conversions, ros-indigo-pcl-ros, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-tf, ros-indigo-visualization-msgs
Homepage: http://ros.org/wiki/humanoid_localization
Standards-Version: 3.9.2

Package: ros-indigo-humanoid-localization
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-geometry-msgs, ros-indigo-message-filters, ros-indigo-nav-msgs, ros-indigo-octomap, ros-indigo-octomap-msgs, ros-indigo-octomap-ros, ros-indigo-pcl-conversions, ros-indigo-pcl-ros, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-tf, ros-indigo-visualization-msgs
Description: 6D localization for humanoid robots based on depth data (laser, point clouds).
 Two observation models are currently available based on OctoMap as 3D map: Ray casting and an end point model (lookup in the distance map). Details can be found in the publication &quot;Humanoid Navigation with Dynamic Footstep Plans&quot; by A. Hornung, K.M. Wurm, and M. Bennewitz; published in IEEE/RSJ International Conference on Intelligent Robots and Systems (IROS), 2010

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-humanoid-localization//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
